commit 966ba2b155a1646d67ac8a8d1f3ec0527a268fb2
Author: Werner Hahn <wh@futureworldsearch.net>
Date:   Mon Sep 25 16:03:48 2017 +0200

    WebshopApi: templates

diff --git a/templates/webpages/shop_order/_transfer_status.html b/templates/webpages/shop_order/_transfer_status.html
index 26b8c822b..24b7bf97d 100644
--- a/templates/webpages/shop_order/_transfer_status.html
+++ b/templates/webpages/shop_order/_transfer_status.html
@@ -1,8 +1,6 @@
 [%- USE LxERP -%][%- USE L -%][%- USE HTML -%]
-[%- USE Dumper -%]
 [% SET data = job.data_as_hash %]
 
-
 <h2>[% LxERP.t8("Watch status") %]</h2>
 
 [% L.hidden_tag('', job.id, id="smt_job_id") %]
diff --git a/templates/webpages/shop_order/list.html b/templates/webpages/shop_order/list.html
index 1da0b17fa..f30644c96 100644
--- a/templates/webpages/shop_order/list.html
+++ b/templates/webpages/shop_order/list.html
@@ -1,9 +1,8 @@
 [%- USE HTML -%][%- USE LxERP -%][%- USE L -%][%- USE T8 -%]
-[% USE Dumper %]
 
 [% L.stylesheet_tag('webshop') %]
 [%- INCLUDE 'common/flash.html' %]
-<h1>[% title %]<span style="float:right;">[% 'Number data sets' | $T8 %]: [% SHOPORDERS.size %]</span></h1>
+<h1>[% title %]<span style="float:right;">[% 'Number of data sets' | $T8 %]: [% SHOPORDERS.size %]</span></h1>
 [%- PROCESS 'shop_order/_filter.html' filter=SELF.models.filtered.laundered %]
 
 <hr>
@@ -147,7 +146,6 @@
  </form>
  <form method="post" action="controller.pl" name="shop_orders_list" id="shoporderslist">
   [% FOREACH shop_order = SHOPORDERS %]
-  [% # Dumper.dump_html(shop_order) %]
     [% IF shop_order.kivi_customer.id && shop_order.kivi_customer.order_lock == 0 && shop_order.open_invoices == 0 %] [% SET transferable = 1 %] [% SET transferable_class = 'class="shop_transferable"' %] [% ELSE %] [% SET transferable = 0 %] [% SET transferable_class = '' %][% END %]
   <tr class="listrow">
     <td>[% HTML.escape(shop_order.shop.description) %]</td>
diff --git a/templates/webpages/shop_order/show.html b/templates/webpages/shop_order/show.html
index e9c22e5ee..a4f2c7a10 100644
--- a/templates/webpages/shop_order/show.html
+++ b/templates/webpages/shop_order/show.html
@@ -176,22 +176,20 @@
   <div style="height: 250px; overflow:auto; margin:15px;">
     <table width="99%">
       <tr class="listheading">
-        <th>[% 'Position' | $T8 %]</th>
-        <th>[% 'Partnumber' | $T8 %]</th>
-        <th>[% 'Part Description' | $T8 %]</th>
-        <th>[% 'Qty' | $T8 %]</th>
-        <th>[% 'Price' | $T8 %]</th>
-        <th>[% 'Extended' | $T8 %]</th>
+        <th>[% 'Position'          | $T8 %]</th>
+        <th>[% 'Partnumber'        | $T8 %]</th>
+        <th>[% 'Partdescriptipion' | $T8 %]</th>
+        <th>[% 'Qty'               | $T8 %]</th>
+        <th>[% 'Price'             | $T8 %]</th>
+        <th>[% 'Extended'          | $T8 %]</th>
       </tr>
-      [% FOREACH pos = IMPORT.shop_order_items %]
       <tr class="listrow">
-        <td>[% count() %]</td>
-        <td>[% HTML.escape(pos.partnumber) %]</td>
-        <td>[% HTML.escape(pos.description) %]</td>
-        <td>[% pos.quantity_as_number%]</td>
-        <td>[% pos.price_as_number%]</td>
-        [% SET extended = pos.price * pos.quantity %]
-        <td>[% LxERP.format_amount(extended,2) %]</td>
+        <td>[% loop.index                                      %]</td>
+        <td>[% HTML.escape(pos.partnumber)                     %]</td>
+        <td>[% HTML.escape(pos.description)                    %]</td>
+        <td>[% pos.quantity_as_number                          %]</td>
+        <td>[% pos.price_as_number                             %]</td>
+        <td>[% LxERP.format_amount(pos.price * pos.quantity,2) %]</td>
       </tr>
       [% END %]
     </table>
@@ -205,4 +203,3 @@ $("input[type=radio]").change(function(){
       $('#transfer').css("display", 'block');
 });
 </script>
-[% # L.dump(IMPORT) %]
diff --git a/templates/webpages/shop_part/_filter.html b/templates/webpages/shop_part/_filter.html
index 3e49a0e90..add0f6bfa 100644
--- a/templates/webpages/shop_part/_filter.html
+++ b/templates/webpages/shop_part/_filter.html
@@ -5,16 +5,14 @@
 <form action='controller.pl' metdod='post' id="shop_part_filter">
   [% L.hidden_tag('filter.shop.obsolete', 0) %]
  <table id='filter_table'>
-
     <tr>
      <td>[% 'Shop' | $T8 %]</td>
      <td>[% L.select_tag('filter.shop_id:eq_ignore_empty', SELF.shops, value_key = 'value', title_key = 'title', default=0) %]</td>
     </tr>
     <tr>
-     <td>[% 'Part marked as "Shop article"' %]
+     <td>[% 'Part marked as "Shop part"' %]
      <td>[% L.yes_no_tag('filter.part.shop', FORM.filter.part.shop, default='1', with_empty=1, empty_title='---') %]</td>
     </tr>
-
  </table>
 
  <p>
diff --git a/templates/webpages/shop_part/_list_articles.html b/templates/webpages/shop_part/_list_articles.html
index 244fb767b..34d404585 100644
--- a/templates/webpages/shop_part/_list_articles.html
+++ b/templates/webpages/shop_part/_list_articles.html
@@ -1,6 +1,4 @@
 [%- USE HTML -%][%- USE LxERP -%][%- USE L -%][%- USE T8 -%]
-[% USE Dumper %]
-
 
 <h1>[% title %]</h1>
 [%- PROCESS 'shop_part/_filter.html' filter=SELF.models.filtered.laundered %]
diff --git a/templates/webpages/shop_part/_list_images.html b/templates/webpages/shop_part/_list_images.html
index 6c811b346..2fa6e8827 100644
--- a/templates/webpages/shop_part/_list_images.html
+++ b/templates/webpages/shop_part/_list_images.html
@@ -1,27 +1,25 @@
 [%- USE HTML %][%- USE L -%][%- USE P -%][%- USE LxERP -%]
 [%- USE T8 %][% USE Base64 %]
-[%- USE Dumper %]
 <table width="100%" id="images_list">
   <thead>
     <tr class="listheading">
       <th width="10px"><img src="image/updown.png" alt="[%- LxERP.t8('reorder item') %]" class="dragdrop"></th>
       <th width="70px"></th>
-      <th>[% 'Title' | $T8 %]</th>
-      <th>[% 'Description' | $T8 %]</th>
-      <th>[% 'Filename' | $T8 %]</th>
+      <th>[% 'Title'          | $T8 %]</th>
+      <th>[% 'Description'    | $T8 %]</th>
+      <th>[% 'Filename'       | $T8 %]</th>
       <th>[% 'Orig. Size w/h' | $T8 %]</th>
-      <th>[% 'Action' | $T8 %]</th>
+      <th>[% 'Action'         | $T8 %]</th>
     </tr>
   </thead>
   <tbody>
    [%-  FOREACH img = IMAGES %]
-   [% # Dumper.dump_html(img) %]
     <tr class="listrow" id="image_id_[%  img.id %]">
       <td><img src="image/updown.png" alt="[%- LxERP.t8('reorder item') %]" class="dragdrop"></td>
       <td width="70px"><img src="data:[%  img.thumbnail_content_type %];base64,[%  img.thumbnail_content.encode_base64 %]" alt="[%  img.file.title %]"></td>
-      <td>[% HTML.escape(img.file.title) %]</td>
+      <td>[% HTML.escape(img.file.title)       %]</td>
       <td>[% HTML.escape(img.file.description) %]</td>
-      <td>[% HTML.escape(img.file.file_name) %]</td>
+      <td>[% HTML.escape(img.file.file_name)   %]</td>
       <td>[% HTML.escape(img.org_file_width) _  ' x ' _ HTML.escape(img.org_file_height) %]</td>
       <td>[% L.button_tag("kivi.File.delete_file(" _ img.file_id _ ", 'ShopPart/ajax_delete_file')", LxERP.t8('Delete'), confirm=LxERP.t8("Are you sure?")) %]</td>
     </tr>
diff --git a/templates/webpages/shop_part/_transfer_status.html b/templates/webpages/shop_part/_transfer_status.html
index bbee02b81..ded2ba7ad 100644
--- a/templates/webpages/shop_part/_transfer_status.html
+++ b/templates/webpages/shop_part/_transfer_status.html
@@ -1,5 +1,5 @@
 [%- USE LxERP -%][%- USE L -%][%- USE HTML -%]
-[%- USE Dumper -%]
+
 [% SET data = job.data_as_hash %]
 
 <h2>[% LxERP.t8("Watch status") %]</h2>
@@ -24,7 +24,7 @@ JOBID: [% job.id %] <p>
    </td>
   </tr>
   <tr>
-   <th valign="top" align="left">[% LxERP.t8("Number of data uploaded:") %]</th>
+   <th valign="top" align="left">[% LxERP.t8("Number of data sets uploaded:") %]</th>
    <td valign="top">[% IF data.status > 0 %][% HTML.escape(data.num_uploaded) %] / [% HTML.escape(data.record_ids.size) %][% ELSE %]–[% END %]</td>
   </tr>
 
@@ -35,9 +35,9 @@ JOBID: [% job.id %] <p>
   –
     <table>
      <tr class="listheader">
-      <th>[% LxERP.t8("Part") %]</th>
-      <th>[% LxERP.t8("Partnumber") %]</th>
-      <th>[% LxERP.t8("Message") %]</th>
+      <th>[% LxERP.t8("Part")       %] </th>
+      <th>[% LxERP.t8("Partnumber") %] </th>
+      <th>[% LxERP.t8("Message")    %] </th>
      </tr>
 
  [% FOREACH message = data.conversion %]
diff --git a/templates/webpages/shop_part/_upload_status.html b/templates/webpages/shop_part/_upload_status.html
index e7285a24a..2209a20a0 100644
--- a/templates/webpages/shop_part/_upload_status.html
+++ b/templates/webpages/shop_part/_upload_status.html
@@ -34,15 +34,15 @@ JOBID: [% job.id %] <p>
   –
     <table>
      <tr class="listheader">
-      <th>[% LxERP.t8("Part") %]</th>
+      <th>[% LxERP.t8("Part")       %]</th>
       <th>[% LxERP.t8("Partnumber") %]</th>
-      <th>[% LxERP.t8("Message") %]</th>
+      <th>[% LxERP.t8("Message")    %]</th>
      </tr>
 
  [% FOREACH message = data.conversion %]
      <tr>
-      <td valign="top">[% HTML.escape(message.id) %]</td>
-      <td valign="top">[% HTML.escape(message.number) %]</td>
+      <td valign="top">[% HTML.escape(message.id)      %]</td>
+      <td valign="top">[% HTML.escape(message.number)  %]</td>
       <td valign="top">[% HTML.escape(message.message) %]</td>
      </tr>
  [% END %]
diff --git a/templates/webpages/shop_part/categories.html b/templates/webpages/shop_part/categories.html
index 80676eb9b..43b73886f 100644
--- a/templates/webpages/shop_part/categories.html
+++ b/templates/webpages/shop_part/categories.html
@@ -3,14 +3,9 @@
 [%- USE L -%]
 [%- USE P -%]
 [%- USE LxERP -%]
-[%- USE Dumper -%]
 
 [%  LxERP.t8("Part") %]: [% HTML.escape(SELF.shop_part.part.displayable_name) %]<br>
-[%  LxERP.t8("Shop") %]: [% HTML.escape(SELF.shop_part.shop.description) %]
-<br>
-[% # Dumper.dump_html(SELF.shop_part.shop_category) %]
-<br>
-[% # Dumper.dump_html(CATEGORIES) %]
+[%  LxERP.t8("Shop") %]: [% HTML.escape(SELF.shop_part.shop.description) %]<br>
 
 <form action="controller.pl" method="post">
   [% BLOCK recurse %]
@@ -21,7 +16,6 @@
         [% checked = '' %]
         [% # path = path _ obj.name %]
         [% # test = path.split('\|') %]
-        [% # Dumper.dump_html(SELF.shop_part.shop_category) %]
         [% IF SELF.shop_part.shop_category.1.grep(obj.name).size %]
           [% checked = 'checked' %]
         [% ELSE %]
@@ -52,4 +46,3 @@
   </div>
     [% L.button_tag("kivi.ShopPart.save_categories(" _ SELF.shop_part.id _", " _ SELF.shop_part.shop.id _")", LxERP.t8("Save"))  %]</td>
 </form>
-
diff --git a/templates/webpages/shop_part/edit.html b/templates/webpages/shop_part/edit.html
index 418a632da..5536ad715 100644
--- a/templates/webpages/shop_part/edit.html
+++ b/templates/webpages/shop_part/edit.html
@@ -3,13 +3,11 @@
 [%- USE L -%]
 [%- USE P -%]
 [%- USE LxERP -%]
-[%- USE Dumper -%]
 
 <p>
 [% LxERP.t8("Part") %]: [% HTML.escape(SELF.shop_part.part.displayable_name) %]<br>
 [% LxERP.t8("Shop") %]: [% HTML.escape(SELF.shop_part.shop.description) %]
 <p>
-[% # Dumper.dump_html(SELF) %]
 <form action="controller.pl" method="post">
   <div>
     [% IF SELF.shop_part.id %]
@@ -55,7 +53,6 @@
      <td>[% L.textarea_tag("shop_part.metatag_description", SELF.shop_part.metatag_description, rows=4) %]</td>
     </tr>
     </table>
-    [% # L.dump(SELF.shop_part) %]
 
     [% IF SELF.shop_part.id %]
     [% L.button_tag("kivi.ShopPart.save_shop_part(" _ SELF.shop_part.id _ ")", LxERP.t8("Save"))  %]</td>
@@ -71,11 +68,6 @@
   </div>
 </form>
 
-
-
 [%- IF SELF.shop_part.part.image && INSTANCE_CONF.get_parts_show_image %]
          <a href="[% SELF.shop_part.part.image | html %]" target="_blank"><img style="[% INSTANCE_CONF.get_parts_image_css %]" src="[% SELF.shop_part.part.image | html %]"/></a>
 [%- END %]
-
-[% # SELF.shop_part.shop_description %]
-[% # L.dump(SELF.shop_part) %]
diff --git a/templates/webpages/shops/form.html b/templates/webpages/shops/form.html
index b904a4d83..280c61b09 100644
--- a/templates/webpages/shops/form.html
+++ b/templates/webpages/shops/form.html
@@ -1,11 +1,9 @@
 [%- USE HTML -%][%- USE LxERP -%][%- USE L -%][%- USE P -%][%- USE T8 -%]
-[%- USE Dumper -%]
 
 [% SET style="width: 400px" %]
 [% SET size=34 %]
 
 <h1>[% HTML.escape(title) %]</h1>
-[% #Dumper.dump_html(SELF.shop) %]
 <form id="form" action="controller.pl" method="post">
 
 [%- INCLUDE 'common/flash.html' %]
diff --git a/templates/webpages/shops/test_shop_connection.html b/templates/webpages/shops/test_shop_connection.html
index d9ff48254..f7033a63d 100644
--- a/templates/webpages/shops/test_shop_connection.html
+++ b/templates/webpages/shops/test_shop_connection.html
@@ -1,7 +1,7 @@
 [%- USE HTML %][%- USE LxERP -%][%- USE L -%]
 [%- IF ok %]
 
- <p class="message_ok">[% LxERP.t8('The connection was to the shop established successfully.') %]</p>
+ <p class="message_ok">[% LxERP.t8('The connection to the shop was established successfully.') %]</p>
  <p>[% LxERP.t8('Version: ')%][% HTML.escape(version) %]</p>
 
 [%- ELSE %]