commit 968ad5fe2968e46a33675dae240bfb9ccaa520dd
Author: Geoffrey Richardson <information@kivitendo-premium.de>
Date:   Tue Sep 26 12:12:19 2017 +0200

    locales aktualisiert

diff --git a/locale/de/all b/locale/de/all
index 3b197d213..edac69325 100755
--- a/locale/de/all
+++ b/locale/de/all
@@ -36,7 +36,6 @@ $self->{texts} = {
   '...done'                     => '...fertig',
   '...on the TODO list'         => '...auf der Aufgabenliste',
   '0% tax with taxkey'          => '0% Steuer mit Steuerschl&uuml;ssel ',
-  '1)'                          => '',
   '1. Quarter'                  => '1. Quartal',
   '2 years'                     => '2 Jahre',
   '2. Quarter'                  => '2. Quartal',
diff --git a/locale/en/all b/locale/en/all
index affa28626..43b1be16e 100644
--- a/locale/en/all
+++ b/locale/en/all
@@ -72,6 +72,7 @@ $self->{texts} = {
   'AP Transaction Storno (one letter abbreviation)' => '',
   'AP Transaction with Storno (abbreviation)' => '',
   'AP Transactions'             => 'Purchase Transactions',
+  'AP template suggestions'     => '',
   'AP transaction posted.'      => '',
   'AP transactions changeable'  => '',
   'AP transactions with sales taxkeys and/or AR transactions with input taxkeys' => '',
@@ -359,6 +360,7 @@ $self->{texts} = {
   'Automatically created invoice for fee and interest for dunning %s' => '',
   'Available'                   => '',
   'Available Prices'            => '',
+  'Available identity fields'   => '',
   'Available qty'               => '',
   'BALANCE SHEET'               => '',
   'BB Balance'                  => '',
@@ -403,6 +405,8 @@ $self->{texts} = {
   'Bank transfer payment list for export #1' => '',
   'Bank transfer via SEPA'      => '',
   'Bank transfers via SEPA'     => '',
+  'Base Transaction Value'      => '',
+  'Base Transaction Value Currency Code' => '',
   'Base unit'                   => '',
   'Basic Data'                  => '',
   'Basic Settings for the Requirement Spec' => '',
@@ -480,6 +484,7 @@ $self->{texts} = {
   'CN'                          => '',
   'CR'                          => '',
   'CSS style for pictures'      => '',
+  'CSV Export successful!'      => '',
   'CSV export'                  => '',
   'CSV export -- options'       => '',
   'CSV import: ar transactions' => '',
@@ -636,6 +641,7 @@ $self->{texts} = {
   'Content'                     => '',
   'Continue'                    => '',
   'Contra'                      => '',
+  'Contra Account'              => '',
   'Contrary to Reduced Master Data this will be shown as discount in records.' => '',
   'Conversion of "birthday" contact person attribute' => '',
   'Conversion to PDF failed: #1' => '',
@@ -646,6 +652,7 @@ $self->{texts} = {
   'Copy requirement spec'       => '',
   'Copy template'               => '',
   'Correct taxkey'              => '',
+  'Cost Center'                 => '',
   'Costs'                       => '',
   'Could not find an entry for this part in the pricegroup.' => '',
   'Could not load class #1 (#2): "#3"' => '',
@@ -761,6 +768,7 @@ $self->{texts} = {
   'Current version'             => '',
   'Current year'                => '',
   'Currently #1 delivery orders can be converted into invoices and printed.' => '',
+  'Custom CSV format'           => '',
   'Custom Variables'            => '',
   'Custom shipto'               => '',
   'Custom variables for module' => '',
@@ -792,8 +800,6 @@ $self->{texts} = {
   'Customer/Vendor (database ID)' => '',
   'Customer/Vendor Name'        => '',
   'Customer/Vendor Number'      => '',
-  'Customer/Vendor name'        => '',
-  'Customer/Vendor number'      => '',
   'Customer/Vendor/Remote name' => '',
   'Customername'                => '',
   'Customernumberinit'          => '',
@@ -855,6 +861,7 @@ $self->{texts} = {
   'Debit Tax (lit)'             => '',
   'Debit Tax Account'           => '',
   'Debit and credit out of balance!' => '',
+  'Debit/Credit Label'          => '',
   'Dec'                         => '',
   'December'                    => '',
   'Decimalplaces'               => '',
@@ -991,6 +998,7 @@ $self->{texts} = {
   'Do you really want to delete this record template?' => '',
   'Do you really want to revert to this version?' => '',
   'Do you really want to save?' => '',
+  'Do you really want to undo the selected SEPA exports? You have to reassign the export again.' => '',
   'Do you really want to unimport the selected documents?' => '',
   'Do you want to <b>limit</b> your search?' => '',
   'Do you want to carry this shipping address over to the new purchase order so that the vendor can deliver the goods directly to your customer?' => '',
@@ -1039,6 +1047,7 @@ $self->{texts} = {
   'Dunning Description'         => '',
   'Dunning Description missing in row ' => '',
   'Dunning Duedate'             => '',
+  'Dunning Invoice'             => '',
   'Dunning Level'               => '',
   'Dunning Level missing in row ' => '',
   'Dunning Process Config saved!' => '',
@@ -1063,6 +1072,7 @@ $self->{texts} = {
   'ELSE'                        => '',
   'ELSTER Export (via Geierlein)' => '',
   'EQUITY'                      => '',
+  'EU Member State and VAT ID Number' => '',
   'EUER'                        => '',
   'Earlier versions of kivitendo contained bugs which might have led to wrong entries in the general ledger.' => '',
   'Edit'                        => '',
@@ -1129,6 +1139,7 @@ $self->{texts} = {
   'Edit payment term'           => '',
   'Edit picture'                => '',
   'Edit pre-defined text'       => '',
+  'Edit preset email strings'   => '',
   'Edit price rule'             => '',
   'Edit pricegroup'             => '',
   'Edit prices and discount (if not used, textfield is ONLY set readonly)' => '',
@@ -1269,6 +1280,7 @@ $self->{texts} = {
   'Example: http://kivitendo.de' => '',
   'Excel'                       => '',
   'Exch'                        => '',
+  'Exchange Rate'               => '',
   'Exchangerate'                => '',
   'Exchangerate Difference'     => '',
   'Exchangerate for payment missing!' => '',
@@ -1338,7 +1350,6 @@ $self->{texts} = {
   'Filter for customer variables' => '',
   'Filter for item variables'   => '',
   'Filter parts'                => '',
-  'Filter vendors'              => '',
   'Financial Controlling'       => '',
   'Financial Controlling Report' => '',
   'Financial Overview'          => '',
@@ -1399,6 +1410,8 @@ $self->{texts} = {
   'GL Transaction (abbreviation)' => '',
   'GL Transactions'             => '',
   'GL search'                   => '',
+  'GL template suggestions'     => '',
+  'GL transaction posted.'      => '',
   'GL transactions changeable'  => '',
   'GLN'                         => '',
   'Gegenkonto'                  => '',
@@ -1496,6 +1509,7 @@ $self->{texts} = {
   'If the automatic creation of invoices for fees and interest is switched on for a dunning level then the following accounts will be used for the invoice.' => '',
   'If the database user listed above does not have the right to create a database then enter the name and password of the superuser below:' => '',
   'If the default transfer out always succeed use this bin for negative stock quantity.' => '',
+  'If yes, delivery order positions are considered "delivered" only if they have been stocked out of the inventory. Otherwise saving the delivery order is considered delivered.' => '',
   'If you enter values for the part number and / or part description then only those bins containing parts whose part number or part description match your input will be shown.' => '',
   'If you have not chosen for example the category revenue for a tax and you choose an revenue account to create a transfer in the general ledger, this tax will not be displayed in the tax dropdown.' => '',
   'If you lock the system normal users won\'t be able to log in.' => '',
@@ -1592,6 +1606,8 @@ $self->{texts} = {
   'Invoice Date'                => '',
   'Invoice Date missing!'       => '',
   'Invoice Duedate'             => '',
+  'Invoice Field 1'             => '',
+  'Invoice Field 2'             => '',
   'Invoice Number'              => '',
   'Invoice Number missing!'     => '',
   'Invoice deleted!'            => '',
@@ -1631,8 +1647,9 @@ $self->{texts} = {
   'Jump to'                     => '',
   'Jun'                         => '',
   'June'                        => '',
-  'KNE-Export erfolgreich!'     => '',
+  'KNE Export successful!'      => '',
   'KNr. beim Kunden'            => '',
+  'KOST Quantity'               => '',
   'Keep the project link the way it is.' => '',
   'Known Column'                => '',
   'Konten'                      => '',
@@ -1653,6 +1670,7 @@ $self->{texts} = {
   'Last Cost'                   => '',
   'Last Credit Note Number'     => '',
   'Last Customer Number'        => '',
+  'Last Dunning'                => '',
   'Last Invoice Number'         => '',
   'Last Purchase Delivery Order Number' => '',
   'Last Purchase Order Number'  => '',
@@ -1687,9 +1705,11 @@ $self->{texts} = {
   'Line endings'                => '',
   'Link direction'              => '',
   'Link to'                     => '',
+  'Link to invoice'             => '',
   'Link to the following project:' => '',
   'Linked Records'              => '',
   'Linked invoices'             => '',
+  'Linked positions will always be reconciled first. If this is set to yes, unlinked positions will be reconciled in a second step. This is necessary in very old databases (with open delivery orders from before 3.4.0) and in businesses where delivery orders are frequently amended. Usually the direct links are faster and more accurate. Defaults to true for historical reasons only.' => '',
   'Liquidity projection'        => '',
   'List Accounts'               => '',
   'List Price'                  => '',
@@ -1848,9 +1868,11 @@ $self->{texts} = {
   'No'                          => '',
   'No %s was found matching the search parameters.' => '',
   'No 1:n or n:1 relation'      => '',
+  'No AP template was found.'   => '',
   'No Company Address given'    => '',
   'No Company Name given'       => '',
   'No Customer was found matching the search parameters.' => '',
+  'No GL template was found.'   => '',
   'No Journal'                  => '',
   'No Vendor was found matching the search parameters.' => '',
   'No action defined.'          => '',
@@ -1865,6 +1887,7 @@ $self->{texts} = {
   'No changes since previous version.' => '',
   'No clients have been created yet.' => '',
   'No contact selected to delete' => '',
+  'No contra account selected!' => '',
   'No customer has been selected yet.' => '',
   'No data was found.'          => '',
   'No default currency'         => '',
@@ -1906,7 +1929,6 @@ $self->{texts} = {
   'No such job #1 in the database.' => '',
   'No summary account'          => '',
   'No template has been selected yet.' => '',
-  'No template was found.'      => '',
   'No text blocks have been created for this position.' => '',
   'No text has been entered yet.' => '',
   'No title yet'                => '',
@@ -1985,6 +2007,7 @@ $self->{texts} = {
   'One or more Perl modules missing' => '',
   'Onhand only sets the quantity in master data, not in inventory. This is only a legacy info field and will be overwritten as soon as a inventory transfer happens.' => '',
   'Only Warnings and Errors'    => '',
+  'Only applies if the previous is set to true. When filling up unlinked positions, consider them matches if ALL of these fields match. For example, in a business with variants that are defined by a special description, description needs to be part of the identity. If delivering several similar order positions by delivery date is common, reqdate should be included in the identity. Serialnumber is useful when the serialnumber in the order and delivery order has to match.' => '',
   'Only booked accounts'        => '',
   'Only due follow-ups'         => '',
   'Only groups that have been configured for the client the user logs in to will be considered.' => '',
@@ -2174,12 +2197,15 @@ $self->{texts} = {
   'Poland'                      => '',
   'Port'                        => '',
   'Portrait'                    => '',
+  'Position identity fields for fill up?' => '',
   'Position type in quotation/order' => '',
   'Post'                        => '',
   'Post Payment'                => '',
   'Post payments'               => '',
   'Post payments for selected invoices' => '',
   'Posting Configuration'       => '',
+  'Posting Key'                 => '',
+  'Posting Text'                => '',
   'Postscript'                  => '',
   'Posustva_coa'                => '',
   'Pre-defined Texts'           => '',
@@ -2193,6 +2219,13 @@ $self->{texts} = {
   'Prepare bank collection via SEPA XML' => '',
   'Prepare bank transfer via SEPA XML' => '',
   'Prepayment'                  => '',
+  'Preset email strings'        => '',
+  'Preset email text for purchase orders' => '',
+  'Preset email text for requests (rfq)' => '',
+  'Preset email text for sales delivery orders' => '',
+  'Preset email text for sales invoices' => '',
+  'Preset email text for sales orders' => '',
+  'Preset email text for sales quotations' => '',
   'Preview'                     => '',
   'Preview Mode'                => '',
   'Previous transdate text'     => '',
@@ -2221,6 +2254,7 @@ $self->{texts} = {
   'Pricegroups'                 => '',
   'Prices'                      => '',
   'Print'                       => '',
+  'Print and Post'              => '',
   'Print automatically'         => '',
   'Print both sided'            => '',
   'Print delivery orders'       => '',
@@ -2425,6 +2459,7 @@ $self->{texts} = {
   'Requested execution date to' => '',
   'Requests for Quotation'      => '',
   'Require a transaction description in purchase and sales records' => '',
+  'Require stock out to consider a delivery order position delivered?' => '',
   'Required by'                 => '',
   'Requirement Spec Status'     => '',
   'Requirement Spec Statuses'   => '',
@@ -2482,6 +2517,7 @@ $self->{texts} = {
   'SEPA message ID'             => '',
   'SEPA message IDs'            => '',
   'SEPA strings'                => '',
+  'SWIFT MT940 format'          => '',
   'Saldo'                       => '',
   'Saldo Credit'                => '',
   'Saldo Debit'                 => '',
@@ -2523,7 +2559,12 @@ $self->{texts} = {
   'Sales quotation #1 has been updated.' => '',
   'Salesman'                    => '',
   'Salesman (database ID)'      => '',
+  'Salesman (login)'            => '',
   'Salesperson'                 => '',
+  'Salutation female'           => '',
+  'Salutation general'          => '',
+  'Salutation male'             => '',
+  'Salutation punctuation mark' => '',
   'Same Filename !'             => '',
   'Same as the quote character' => '',
   'Sat. Fax'                    => '',
@@ -2586,6 +2627,7 @@ $self->{texts} = {
   'Select type of transfer'     => '',
   'Select type of transfer in'  => '',
   'Selected'                    => '',
+  'Selected identity fields'    => '',
   'Selection'                   => '',
   'Selection fields: The option field must contain the available options for the selection. Options are separated by \'##\', for example \'Early##Normal##Late\'.' => '',
   'Sell Price'                  => '',
@@ -2630,6 +2672,7 @@ $self->{texts} = {
   'Setup Menu'                  => '',
   'Ship to (database ID)'       => '',
   'Ship via'                    => '',
+  'Shipped Quantity Algorithm'  => '',
   'Shipping Address'            => '',
   'Shipping Point'              => '',
   'Shipping address (name)'     => '',
@@ -2684,6 +2727,7 @@ $self->{texts} = {
   'Show items from invoices individually' => '',
   'Show mappings (csv_import)'  => '',
   'Show old dunnings'           => '',
+  'Show only marked as paid invoices' => '',
   'Show overdue sales quotations and requests for quotations...' => '',
   'Show parts'                  => '',
   'Show parts longdescription (notes) in select list' => '',
@@ -2722,6 +2766,7 @@ $self->{texts} = {
   'Sold order items'            => '',
   'Soldtotal does not make sense without any bsooqr options' => '',
   'Solution'                    => '',
+  'Sorry, I am too stupid to figure out the default warehouse/bin and the sold qty. I drop the default warehouse/bin option.' => '',
   'Sort By'                     => '',
   'Source'                      => '',
   'Source BIC'                  => '',
@@ -2853,9 +2898,9 @@ $self->{texts} = {
   'Telephone'                   => '',
   'Template'                    => '',
   'Template Code'               => '',
+  'Template Description'        => '',
   'Template database'           => '',
   'Template date'               => '',
-  'Template suggestions'        => '',
   'Templates'                   => '',
   'Terms missing in row '       => '',
   'Test database connectivity'  => '',
@@ -2887,6 +2932,7 @@ $self->{texts} = {
   'The ID #1 is not a valid database ID.' => '',
   'The LDAP server "#1:#2" is unreachable. Please check config/kivitendo.conf.' => '',
   'The MT940 import needs an import profile called MT940' => '',
+  'The Mail strings have been saved.' => '',
   'The PDF has been created'    => '',
   'The PDF has been printed'    => '',
   'The SEPA export has been created.' => '',
@@ -2984,6 +3030,7 @@ $self->{texts} = {
   'The documents have been sent to the printer \'#1\'.' => '',
   'The dunnings have been printed.' => '',
   'The email has been sent.'    => '',
+  'The email was not sent due to the following error: #1.' => '',
   'The employee is missing.'    => '',
   'The end date is the last day for which invoices will possibly be created.' => '',
   'The execution schedule is invalid.' => '',
@@ -3037,7 +3084,6 @@ $self->{texts} = {
   'The name must only consist of letters, numbers and underscores and start with a letter.' => '',
   'The new requirement spec template will be a copy of \'#1\'.' => '',
   'The new requirement spec will be a copy of \'#1\' for customer \'#2\'.' => '',
-  'The next partnumber in the number range already exists!' => '',
   'The number of days for full payment' => '',
   'The numbering will start at 1 with each requirement spec.' => '',
   'The object has been created.' => '',
@@ -3051,6 +3097,7 @@ $self->{texts} = {
   'The package name is invalid.' => '',
   'The partnumber already exists!' => '',
   'The partnumber already exists.' => '',
+  'The partnumber is already being used' => '',
   'The partnumber is missing.'  => '',
   'The parts for this delivery order have already been transferred in.' => '',
   'The parts for this delivery order have already been transferred out.' => '',
@@ -3105,6 +3152,7 @@ $self->{texts} = {
   'The selected currency'       => '',
   'The selected database is still configured for client "#1". If you delete the database that client will stop working until you re-configure it. Do you still want to delete the database?' => '',
   'The selected exports have been closed.' => '',
+  'The selected exports have been undone.' => '',
   'The selected warehouse does not exist.' => '',
   'The selected warehouse is empty, or no stocked items where found that match the filter settings.' => '',
   'The session has expired. Please log in again.' => '',
@@ -3283,6 +3331,7 @@ $self->{texts} = {
   'Time/cost estimate actions'  => '',
   'Timerange'                   => '',
   'Timestamp'                   => '',
+  'Tired of copying always nice phrases for this message? Click here to use the new preset message option!' => '',
   'Title'                       => '',
   'To'                          => '',
   'To (email)'                  => '',
@@ -3311,6 +3360,8 @@ $self->{texts} = {
   'Transaction %d cancelled.'   => '',
   'Transaction Date missing!'   => '',
   'Transaction ID missing.'     => '',
+  'Transaction Value'           => '',
+  'Transaction Value Currency Code' => '',
   'Transaction deleted!'        => '',
   'Transaction description'     => '',
   'Transaction has already been cancelled!' => '',
@@ -3372,6 +3423,7 @@ $self->{texts} = {
   'UStVa Einstellungen'         => '',
   'Unbalanced Ledger'           => '',
   'Unchecked custom variables will not appear in orders and invoices.' => '',
+  'Undo SEPA exports'           => '',
   'Unfinished follow-ups'       => '',
   'Unfortunately you have no warehouse defined.' => '',
   'Unimport all'                => '',
@@ -3436,6 +3488,7 @@ $self->{texts} = {
   'Use default booking group because wanted is missing' => '',
   'Use default warehouse for assembly transfer' => '',
   'Use existing templates'      => '',
+  'Use fill up when calculating shipped quantities?' => '',
   'Use linked items'            => '',
   'Use master default bin for Default Transfer, if no default bin for the part is configured' => '',
   'Use this storage backend for all generated PDF-Files' => '',
@@ -3485,7 +3538,6 @@ $self->{texts} = {
   'Vendor Order Number'         => '',
   'Vendor deleted!'             => '',
   'Vendor details'              => '',
-  'Vendor filter for AP transaction templates' => '',
   'Vendor missing!'             => '',
   'Vendor saved'                => '',
   'Vendor saved!'               => '',
@@ -3518,6 +3570,7 @@ $self->{texts} = {
   'Warn before saving orders with duplicate parts (new controller only)' => '',
   'Warning'                     => '',
   'Warning! Loading a draft will discard unsaved data!' => '',
+  'Warning: One or more field value are not in valid DATEV format at:' => '',
   'Warnings and errors'         => '',
   'Watch status'                => '',
   'WebDAV'                      => '',
@@ -3543,7 +3596,9 @@ $self->{texts} = {
   'Working copy identical to version number #1' => '',
   'Working copy without version' => '',
   'Working copy; no description yet' => '',
+  'Working on export'           => '',
   'Write bin to default bin in part?' => '',
+  'Wrong field value \'#1\' for field \'#2\' for the transaction with amount \'#3\'' => '',
   'Wrong tax keys recorded'     => '',
   'Wrong taxes recorded'        => '',
   'X'                           => '',